% Find nearest neighbors of m query points in the collection of n points
d = 2;   % dimensions
n = 1e5; % number of points in the dataset
m = 1e3; % number of query points
k = 3;   % number of nearest neighbors
eps = 1; % tolerance (eps=1 - exact search)

X = randn(d,n);
Y = randn(d,m);

tree = ann('init', X);
[idx, dist] = ann('search', tree, Y, k, 'eps', eps);
% idx = kxm matrix with indices to the n points in the dataset denoting the
%       nearest neigbors of each query point
%       idx(k,m) - index of the k-th nearest neighbor of m-th point
% dist = kxm matrix of corresponding Euclidean distances
ann('deinit', tree);





