function [A, B, shape] = calc_A_B(shape, fem_deg)
%function [A, B, shape] = calc_A_B(shape, fem_deg)

[intFF, intDFDF] = calc_intFF_intDFDF(shape, fem_deg);
%[intFF, intDFDF] = calc_intFF_intDFDF_new(shape, fem_deg);

[shape, Triv] = refine_mesh(shape, fem_deg);

num_fefine = size(Triv, 2);

num_vert = size(shape.X, 1);
A = sparse(num_vert, num_vert);
B = sparse(num_vert, num_vert);

col1 = repmat((1:num_fefine),  num_fefine, 1);
col2 = repmat((1:num_fefine)', 1, num_fefine);
Idx = sub2ind(size(A), Triv(:, col1(:)), Triv(:, col2(:)));

for k=1:numel(Idx)
    A(Idx(k)) = A(Idx(k)) + intDFDF(k);
    B(Idx(k)) = B(Idx(k)) + intFF(k);
end

% make sure A and B are symmetric
A = (A + A')*0.5;
B = (B + B')*0.5;
%assert(all(diag(A) > 0));
%assert(all(diag(B) > 0));
end % function calc_A_B
