function [shape0, v_remove_idx] = intersect_shape(shape0, shape1, update_fields)
% shape0 = the intersection between shape0 and shape1
% update fields is an optional cell array.
% the rows corresponding to the vertices that are removed from X, Y, Z
% are removed from all fields in update_fields

v_remove_idx = ~ismember([shape0.X, shape0.Y, shape0.Z], [shape1.X, shape1.Y, shape1.Z], 'rows');
v_remove_idx = find(v_remove_idx);
shape0 = vertex_remove(shape0, v_remove_idx);

if(nargin == 3)
    for i=1:numel(update_fields)
        eval(['shape0.' update_fields{i} '(v_remove_idx, :) = [];']);
    end
end

%shape0 = tri_remove(shape0, ~ismember(shape0.TRIV, shape1.TRIV, 'rows'));
