function [num_edge, edges_to_uedges_idx, uedges] = tri_edges(Triv)
% function [idx_edge] = tri_idx_edge(Triv)
% idx_edge is a num_tri x 3 matrix.
% the values of idx_edge range between 1 and the number of edges in the mesh
% idx_edge(i, :) holds the edge indices of the edges in triangle i [12, 13, 23]
num_tri = size(Triv, 1);
[Tri_12, Tri_13, Tri_23] = tri_edge_idx(Triv);
edges = [Tri_12; Tri_13; Tri_23];
edges = sort(edges, 2);
[uedges, uedges_to_edges_idx, edges_to_uedges_idx] = unique(edges, 'rows');
num_edge = size(uedges, 1);
edges_to_uedges_idx = reshape(edges_to_uedges_idx, num_tri, 3);
