function [shape, vertex_remove_idx] = tri_remove(shape, tri_remove_idx)

shape.TRIV(tri_remove_idx, :) = [];

num_vert_old = numel(shape.X);
vertex_remove_idx = setdiff([1:num_vert_old]', shape.TRIV(:));
shape.X(vertex_remove_idx) = []; shape.Y(vertex_remove_idx) = []; shape.Z(vertex_remove_idx) = [];
num_vert_new = numel(shape.X);

vertex_keep_idx = 1:num_vert_old;
vertex_keep_idx(vertex_remove_idx) = [];
new_map = zeros(1, num_vert_old);
new_map(vertex_keep_idx) = 1:num_vert_new;

shape.TRIV = new_map(shape.TRIV);

assert(isempty(shape.TRIV(:)) || max(shape.TRIV(:)) <= length(shape.X));
assert(isempty(shape.TRIV(:)) || min(shape.TRIV(:)) > 0);
%figure; trimesh(shape.TRIV, shape.X, shape.Y, shape.Z); title('mesh without the removed idx');


