SHAPES = dir(fullfile(EVECS_DIR, FILES_TO_PROCESS));
SHAPES = {SHAPES.name};
%SHAPES = SHAPES(1:225); %SHAPES(226:end);
%SHAPES = SHAPES(1:2:end);
%SHAPES = SHAPES(186:230);
%SHAPES = SHAPES(407+40:end);

% Statistics
tic;
nerr  = 0;
nskip = 0;
nok   = 0;
fprintf(1, 'Computing geodesic distances...\n');


% Create directories
warning off;
mkdir([DIFFDIST_DIR '.geodesic']);
warning on;

for s = 9:length(SHAPES),
    
    shapename = SHAPES{s};
    fprintf(1, '  %-30s \t ', shapename);

    if SKIP_EXISTING && exist(fullfile([DIFFDIST_DIR '.geodesic'], shapename), 'file'),
           nskip = nskip+1;
           fprintf(1, 'Skipped\n');
           continue;
    end          
    
    load(fullfile(SHAPE_DIR, shapename), 'shape');

                if length(shape.X) > MAX_VERTICES,
                    nskip = nskip+1;
                    continue; 
                end                
    
    
    D = {fastmarch(shape.TRIV, shape.X, shape.Y, shape.Z)};
    T = [Inf];
        
    save(fullfile([DIFFDIST_DIR '.geodesic'], shapename), 'D', 'T');
    
    % Save result
    nok = nok+1;    
    fprintf(1, 'OK\n');
    
end

% Statistics
fprintf(1, '\nComputation complete\n');
fprintf(1, ' Elapsed time:   %s\n', format_time(toc));
fprintf(1, ' Total Shapes:   %d\n', length(SHAPES));
fprintf(1, ' Computed:       %d\n', nok);
fprintf(1, ' Skipped:        %d\n', nskip);
fprintf(1, ' Errors:         %d\n', nerr);

