function print_perf(varargin)

if length(varargin) == 3,
    fout = 1;
else
    fout = varargin{1};
    varargin = varargin(2:end);
end

DATA   = varargin{1};
XLABELS = varargin{2};
YLABELS = varargin{3};

nx = max(cellfun(@length, XLABELS, 'UniformOutput', true));
ny = max(cellfun(@length, YLABELS, 'UniformOutput', true));

fs_ylabel = ['%-' sprintf('%d',ny+2) 's'];
fs_xlabel = [' %-' sprintf('%d',nx+2) 's '];

latex = true;
markbest = true;

fs_num = '%5.2f%%'; % fs_num = '%6.4f';
if latex,
    fs_num = '%5.2f\\%%'; % fs_num = '%6.4f';
end

fprintf(fout, fs_ylabel, 'Transformation');
if latex, fprintf(fout, ' & '); end
for s = 1:length(XLABELS),
    fprintf(fout, fs_xlabel, XLABELS{s});
    if latex, 
            if s<length(XLABELS),
                fprintf(fout, ' & '); 
            else
                fprintf(fout, ' \\\\'); 
            end
        end
end
fprintf(fout, '\n');
for x = 1:length(YLABELS),
    fprintf(fout, fs_ylabel, YLABELS{x});
    if latex, fprintf(fout, ' & '); end
    for s = 1:length(XLABELS),
        num = DATA(x,s);
        if isnan(num),
            num = '------';
        else
            num = sprintf(fs_num, num*100);
        end
        if markbest & DATA(x,s) >= max(DATA(x,:)),
            num = ['{\bf ' num '}'];
        end
        fprintf(fout, fs_xlabel, num);
        if latex, 
            if s<length(XLABELS),
                fprintf(fout, ' & '); 
            else
                fprintf(fout, ' \\\\'); 
            end
        end
    end
    
    fprintf(fout, '\n');
end
