% experiment_mAP
% Error rates of SS-BoFs by class
%
% (C) Copyright Alex Bronstein, Michael Bronstein, Maks Ovsjanikov,
% Stanford University, 2009. All Rights Reserved.

% Fix vocabulary
v = find(strcmpi(cellfun(@chop_extension, VOCABS, 'UniformOutput', false), BOF_VOCAB));
t = 2; % Remove hard-coding

% Output settings
fprintf(1, 'Error rates by class\n');
if t==1,
    b = 'BoF';
    dist = BOF_DISTANCE;
else
    b = sprintf('SS-BoF (%.0f)', TIME_KERNEL(t-1));
    dist = SSBOF_DISTANCE;
end
fprintf(1, 'LB: %s Vocab: %s  %s  Distance: %s\n', LB_PARAM, VOCABS{v}, b, dist);

% Compute distance
DIST = bofdist(BOFS{v}{t}, dist);

xforms = unique(xform);
mAP = zeros(length(xforms), 4);
for x=1:length(xforms)
    idxq  = find(strcmpi(xform, xforms(x)) & (shapeid<=15) & ( ~strcmp(xforms(x), 'noise') |  (strength <= 3)) );
        
    idxd = find(~strcmpi(xform, xforms(x)));

    mAP(x,:) = calculate_perf(DIST, idxq, idxd, MASK); % map = [map eer fpr1 fpr01];
    fprintf(1, '   %-20s \t mAP = %5.2f%%\n', xforms{x}, mAP(x, 1)*100);    
end

mAP = mAP(:, 1) * 100;
save(fullfile(PERF_DIR, 'mAP'), 'mAP', 'xforms');





