function [] = plot_perf()
startup;

%% eer, fpr
lb_params = {'cot', 'neu', 'dir', 'euc'};
clrs = {'b', 'r', 'c', 'm'};
for i=1:length(lb_params)
    load(fullfile(DATA_ROOT_DIR, ['perf.' lb_params{i}], 'err_by_class'), 'EER', 'FPR1', 'FPR01', 'ROC', 'PRRE', 'xforms');
    EERS(:,i) = EER;
    FPR1S(:,i) = FPR1;
    FPR01S(:,i) = FPR01;
    ROCS.(lb_params{i}) = ROC;
    PRRES.(lb_params{i}) = PRRE;
end

% remove all
idx = strcmpi(xforms, 'all');
xforms(idx) = [];
EERS(idx, :) = [];
FPR1S(idx, :) = [];
FPR01S(idx, :) = [];

figure;
set(gcf, 'Units', 'normalized');

subplot(4,1,1);
sub_plot_perf(EERS, 'EER', clrs);

lgnd = strrep(lb_params, 'euc', 'belkin');
    
legend(lgnd, 'Units', 'normalized', 'Orientation', 'horizontal', ...
    'Position', [0.1298,0.9346,0.5411,0.0571]);

subplot(4,1,2);
sub_plot_perf(FPR1S, 'FPR@1%', clrs);

subplot(4,1,3);
sub_plot_perf(FPR01S, 'FPR@0.1%', clrs);

%% mAP
for i=1:length(lb_params)
    load(fullfile(DATA_ROOT_DIR, ['perf.' lb_params{i}], 'mAP'), 'mAP', 'xforms');
    mAPS(:, i) = mAP;
end


subplot(4,1,4);
sub_plot_perf(mAPS, 'mAP', clrs);

set(gca, 'XTickLabel', get_xticklbl(xforms));

%%
save_fig('perf', FIG_DIR);


end % function [] = plot_perf()

%%
function [xticklbl] = get_xticklbl(xforms)
xticklbl = xforms;
xticklbl = strrep(xticklbl, 'isometry', 'iso');
xticklbl = strrep(xticklbl, 'topology', 'topo');
end

%%
function [] = sub_plot_perf(Y, y_label, clrs)
h = bar('v6', Y);
for i=1:length(h)
    set(h(i),'facecolor', clrs{i});
end
%set(gca,'xlim',[1 length(Y)]);
ylabel(y_label);
ylim([min(Y(:))*0.9, max(Y(:))]);
set(gca, 'XTickLabel', '');
end


