function [idx,D] = fps(shape, N);

idx = [1];
dmin = repmat(Inf, [length(shape.X) 1]);
str = ''; 
tic;
for k=2:N,
    D0 = repmat(Inf, [length(shape.X) 1]);
    D0(idx(end)) = 0;
    
    % TODO: this is extremely inefficient as the grid is re-initialized at
    % each iteration!
    D = fastmarch(shape.TRIV, shape.X, shape.Y, shape.Z, D0, struct('mode', 'single'));
    dmin = min(dmin,D(:));
    D(isinf(D)) = NaN;
    
    [dmax,i] = max(dmin);
    idx(k)= i;
 %   str = mprintf(str, 'Sampling: %d points  radius %f...', k, dmax);
end
D0 = repmat(Inf, [length(shape.X) 1]);
D0(idx(end)) = 0;
D = fastmarch(shape.TRIV, shape.X, shape.Y, shape.Z, D0, struct('mode', 'single'));

%mprintf(str, 'Sampled %d points with radius %f in %s\n', k, dmax, format_time(toc));
