function shape = loadoff(filename)

shape = [];

f = fopen(filename, 'rt');

fgetl(f);

n = sscanf(fgetl(f), '%d %d %d');
nv = n(1);
nt = n(2);
ne = n(3);
data = fscanf(f, '%f');


if mod(length(data)-nt*4,nv) == 0, t = 4;
elseif mod(length(data)-nt*7,nv) == 0, t = 7;
end

shape.TRIV = reshape(data(end-t*nt+1:end), [t nt]);
if t == 7,
    shape.tri_labels = shape.TRIV(5,:);
end
shape.TRIV = shape.TRIV([2 3 4],:)'+1;

data = data(1:end-t*nt);
data = reshape(data, [length(data)/nv nv]);

shape.X = data(1,:)';
shape.Y = data(2,:)';
shape.Z = data(3,:)';

if size(data,1) >= 5,
    shape.u = data(4,:);
    shape.v = data(5,:);
end

if size(data,1) >= 6,
    shape.desc = data(6,:);
end

fclose(f);
