function [Nt,Nv,At] = normals(T, X)

Nt = cross(X(T(:,1),:)-X(T(:,3),:), X(T(:,2),:)-X(T(:,3),:));
At = 0.5*sqrt(sum(Nt.^2,2));

if nargout > 1,
    % Face-to-vertex interpolation matrix
    F = sparse([T(:,1); T(:,2); T(:,3)], [1:size(T,1), 1:size(T,1), 1:size(T,1)]', ones(size(T,1)*3,1), length(X), size(T,1));
    s = sum(F,2);
    o = [s(T(:,1)); s(T(:,2)); s(T(:,3))];
    F = sparse([T(:,1); T(:,2); T(:,3)], [1:size(T,1), 1:size(T,1), 1:size(T,1)]', 1./o, length(X), size(T,1));
    Nv = normalize(F*Nt,2,2);
end

Nt = normalize(Nt,2,2);