function SHAPES = xform_localscale(shape, minscale, maxscale, minsigma, maxsigma, minpoints, maxpoints, maxstrength, flag)

% Farthest point sampling
N = 2*maxpoints;

idx = [1];
DD = zeros(length(shape.X), N);
dmin = repmat(Inf, [length(shape.X) 1]);
str = ''; 
tic;
for k=2:N,
    D0 = repmat(Inf, [length(shape.X) 1]);
    D0(idx(end)) = 0;
    
    % TODO: this is extremely inefficient as the grid is re-initialized at
    % each iteration!
    D = fastmarch(shape.TRIV, shape.X, shape.Y, shape.Z, D0, struct('mode', 'single'));
    dmin = min(dmin,D(:));
    D(isinf(D)) = NaN;
    DD(:,k-1) = D;
    
    [dmax,i] = max(dmin);
    idx(k)= i;
end


SHAPES = {};

%n = calc_normals(shape);
[Nt,n] = normals(shape.TRIV, [shape.X shape.Y shape.Z]);

idx_ = randperm(length(idx));
for strength = 1:maxstrength,
    
    if maxstrength == 1
        lambda = 0;
    else
        lambda = (strength-1)/(maxstrength-1);
    end    
    
    npoints  = round( (maxpoints*lambda+minpoints*(1-lambda)));
    sigma  = round( (maxsigma*lambda+minsigma*(1-lambda)));
    scale  = round( (maxscale*lambda+minscale*(1-lambda)));
    
    shape_ = shape;
    for k = 1:npoints
        D0 = repmat(Inf, [length(shape.X) 1]);
        D0(idx(idx_(k))) = 0;
        D = fastmarch(shape.TRIV, shape.X, shape.Y, shape.Z, D0, struct('mode', 'single'));

        w = sum(exp(-D.^2/sigma^2),2)*scale;
        
        shape_.X = shape_.X + w.*n(:,1);
        shape_.Y = shape_.Y + w.*n(:,2);
        shape_.Z = shape_.Z + w.*n(:,3);        
    end

    % find correspondence - trivial
    if flag
        [shape_.t,shape_.u] = find_corr(shape);
    end

    
    SHAPES{strength} = shape_;
    
%    h=trisurf(shape_.TRIV,shape_.X,shape_.Y,shape_.Z,w); axis image, %shading interp
    
end


% 
% for k = 1:maxstrength
%     shape_ = SHAPES{k}
% subplot(1,maxstrength,k)
% h=trisurf(shape_.TRIV,shape_.X,shape_.Y,shape_.Z); axis image, shading interp, lighting phong, camlight
% end
