function SHAPES = xform_microholes(shape, minholes, maxholes, maxstrength, flag)

idxt = randperm(size(shape.TRIV,1));

SHAPES = {};
for strength = 1:maxstrength,
    
    % Hole settings
    if maxstrength == 1
        lambda = 0;
    else
        lambda = (strength-1)/(maxstrength-1);
    end
    
    n  = round((minholes*(1-lambda)+maxholes*lambda)*length(idxt));
    
    shape1 = reindex_mesh(shape, [], setdiff(1:size(shape.TRIV,1), idxt(1:n)));
    
    % find correspondence
    if flag
        [shape1.t,shape1.u] = find_corr(shape,shape1);
    end
    
    SHAPES{strength} = shape1;
end
