function SHAPES = xform_partial(shape, maxstrength, offset, flag)

if nargin < 3, offset = 0; end

shape0 = shape;

Zmax = 5; %0.2;

[Nt,Nv,A0] = normals(shape.TRIV, [shape.X shape.Y shape.Z]);
A0 = sum(A0);

warning off;
mkdir('temp');
delete('temp\*.*');
warning on;

shape2ply(shape, 'temp\input.ply');

fout = fopen('temp\settings.txt', 'wt');
fprintf(fout, 'gui_width 600\n');
fprintf(fout, 'gui_height 500\n');
fprintf(fout, 'model_check_orientation false\n');
fprintf(fout, 'model_show_boundary false\n');
fprintf(fout, 'model_rotate_base %ff\n',offset);
fprintf(fout, 'model_rotate_x 0.0f\n');
fprintf(fout, 'range_image_axis 0.0f 0.0f 1.0f\n');
fprintf(fout, 'range_image_degrees %ff\n', 180/(maxstrength-1));
fprintf(fout, 'range_image_max_iter %d\n',  maxstrength);
fprintf(fout, 'range_image_sampling 1\n');
fclose(fout);

[s,q] = dos(sprintf('mesh_tool.exe temp/input.ply -r -s temp/settings.txt -o temp'));

area = zeros(maxstrength,1);
for vv = 0:maxstrength-1,
    [X,Y,Z,flag] = loadmul(sprintf('temp\\input-range-%03d.mul', vv));

    IDX = reshape(1:length(X(:)), size(X));
    idx00 = IDX([1:end-1],[1:end-1]);
    idx01 = IDX([1:end-1],[2:end]);
    idx10 = IDX([2:end],[1:end-1]);
    idx11 = IDX([2:end],[2:end]);
    TRIV = [[idx00(:) idx01(:) idx11(:)]; [idx00(:) idx11(:) idx10(:)]];

    v1 = [X(TRIV(:,1)) Y(TRIV(:,1)) Z(TRIV(:,1))];
    v2 = [X(TRIV(:,2)) Y(TRIV(:,2)) Z(TRIV(:,2))];
    v3 = [X(TRIV(:,3)) Y(TRIV(:,3)) Z(TRIV(:,3))];
    e12 = v2-v1;
    e13 = v3-v1;
    e23 = v3-v2;
    zmax = max(max(abs(e12(:,3)), abs(e13(:,3))), abs(e23(:,3)));

    shape = struct('X',X(:),'Y',Y(:),'Z',Z(:),'TRIV',TRIV);
    idxt  = find(zmax < Zmax);
    idxv  = find(flag ~= 0);
    shape = reindex_mesh(shape, idxv, idxt);

    [Nt,Nv,A1] = normals(shape.TRIV, [shape.X shape.Y shape.Z]);
    A1 = sum(A1);
    area(vv+1) = A1/A0; 

    % find correspondence
    if flag
        [shape.t,shape.u] = find_corr(shape0,shape);
    end
    
    SHAPES{vv+1} = shape;
    
end

[area,idx] = sort(area, 'descend');
SHAPES = SHAPES(idx);



