function SHAPES = xform_shotnoise(shape, minsigma, maxsigma, minpoints, maxpoints, maxstrength, flag)

N = randn(length(shape.X), 1);
[Nt,Nv] = normals(shape.TRIV, [shape.X shape.Y shape.Z]);
N = bsxfun(@times, Nv, N);

SHAPES = {};
idx = randperm(length(shape.X));
for strength = 1:maxstrength,
    
    if maxstrength == 1
        lambda = 0;
    else
        lambda = (strength-1)/(maxstrength-1);
    end    
    
    npoints  = round( (maxpoints*lambda+minpoints*(1-lambda)));
    sigma  = round( (maxsigma*lambda+minsigma*(1-lambda)));
    
    
    shape1 = shape;
    shape1.X(idx(1:npoints)) = shape1.X(idx(1:npoints)) + N(idx(1:npoints),1)*sigma;
    shape1.Y(idx(1:npoints)) = shape1.Y(idx(1:npoints)) + N(idx(1:npoints),2)*sigma;
    shape1.Z(idx(1:npoints)) = shape1.Z(idx(1:npoints)) + N(idx(1:npoints),3)*sigma;

    % find correspondence
    if flag
        [shape1.t,shape1.u] = find_corr(shape,shape1);
    end
    
    
    SHAPES{strength} = shape1;
end
